<?php
/**
 * $Horde: rakim/admin/addOrganization.php,v 1.9 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__) . '/..');
require_once RAKIM_BASE . '/lib/base.php';

if (!Auth::isAdmin('rakim:admin')) {
    Horde::authenticationFailureRedirect();
}

if (Util::getPost('organization_name_entered')) {
    $name = Util::getPost('organization_name_entered');
	$checkOrganizationNameQuery = 'SELECT count(*) FROM rakim_organizations WHERE organization_name = ' . $db->quote($name);
    Horde::logMessage($checkOrganizationNameQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

	$nameUnavailable = $db->getOne($checkOrganizationNameQuery);
    if (is_a($nameUnavailable, 'PEAR_Error')) {
        Horde::logMessage($nameUnavailable, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(sprintf(_("An error occurred adding the organization '%s': %s"), $name, $result->getMessage()), 'horde.error');
    } elseif ($nameUnavailable) {
        $notification->push(sprintf(_("The name '%s' is already taken."), $name), 'horde.error');
	} else {
        $newId = $db->nextId('rakim_organizations_id');
        if (is_a($newId, 'PEAR_Error')) {
            Horde::logMessage($newId, __FILE__, __LINE__, PEAR_LOG_ERR);
            $notification->push(sprintf(_("An error occurred adding the organization '%s': %s"), $name, $result->getMessage()), 'horde.error');
        } else {
            $addOrganizationQuery = 'INSERT INTO rakim_organizations (organization_id, organization_name) VALUES (' . (int)$newId . ', ' . $db->quote($name) . ')';
            Horde::logMessage($addOrganizationQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

            $result = $db->query($addOrganizationQuery);
            if (is_a($result, 'PEAR_Error')) {
                Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
                $notification->push(sprintf(_("An error occurred adding the organization '%s': %s"), $name, $result->getMessage()), 'horde.error');
            } else {
                $notification->push(sprintf(_("The organization '%s' has been added."), $name), 'horde.success');
            }
		}
    }
}

$title = _("Add Organization");
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';
require RAKIM_TEMPLATES . '/admin/addOrganization.inc';
addOrganizationForm();
require $registry->get('templates', 'horde') . '/common-footer.inc';
