<?php
/**
 * $Horde: rakim/data.php,v 1.10 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 */

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once RAKIM_BASE . '/lib/DateRange.php';
require_once 'Horde/Data.php';
require_once 'Horde/Variables.php';

if (!Auth::isAdmin('rakim:admin')) {
    Horde::authenticationFailureRedirect();
}

$vars = &Variables::getDefaultVariables();

if ($vars->get('formname') == 'chatrangeform') {
    $form = $form = &Horde_Form::singleton('ChatRangeForm', $vars);
    $form->getInfo($vars, $info);
    $start = (int)$info['chat_report_start'];
    $end   = (int)$info['chat_report_end'];

    $data = $db->getAll('SELECT * FROM rakim_archived_sessions WHERE session_guest_login_time >= ' . $start . ' AND session_guest_login_time <= ' . $end, DB_FETCHMODE_ASSOC);
} else {
    $form = $form = &Horde_Form::singleton('EmailRangeForm', $vars);
    $form->getInfo($vars, $info);
    $start = (int)$info['email_report_start'];
    $end   = (int)$info['email_report_end'];

    $data = $db->getAll('SELECT * FROM rakim_archived_emails WHERE email_time_asked >= ' . $start . ' AND email_time_asked <= ' . $end . ' ORDER BY email_id', DB_FETCHMODE_ASSOC);
    $responses = $db->getAll('SELECT r.* FROM rakim_archived_email_responses r LEFT JOIN rakim_archived_emails e ON e.email_id = r.email_id WHERE e.email_time_asked >= ' . $start . ' AND e.email_time_asked <= ' . $end . ' ORDER BY e.email_id', DB_FETCHMODE_ASSOC);
    if (!is_a($data, 'PEAR_Error') && count($data) &&
        !is_a($responses, 'PEAR_Error')) {

        // Make sure the first row has at least an empty response, so
        // that 'response' gets into the column headers.
        $data[0]['response'] = '';

        // Set the initial pointer.
        $i = 0;
        $ptr = &$data[$i];

        // Loop through the responses.
        foreach ($responses as $response) {
            // Loop forward in $data until we're on the right email.
            while ($ptr['email_id'] != $response['email_id']) {
                $i++;
                $ptr = &$data[$i];
            }

            // If there's already a response there, add some newlines;
            // otherwise, initialize the 'response' entry.
            if (empty($ptr['response'])) {
                $ptr['response'] = '';
            } else {
                $ptr['response'] .= "\n\n";
            }

            // Add the current response.
            $ptr['response'] .= 'Response sent ' . strftime('%x %X', $response['response_time']) . "\n" . $response['response_text'];
        }
    }
}

if (is_a($data, 'PEAR_Error')) {
    Horde::logMessage($data, __FILE__, __LINE__, PEAR_LOG_ERR);
    $notification->push(sprintf(_("There was an error generating your report: %s"), $data->getMessage()), 'horde.error');
    header('Location: ' . Horde::applicationUrl('reports.php?dateselect=1', true));
    exit;
} elseif (!count($data)) {
    $notification->push(sprintf(_("There were no records found between %s and %s."), strftime('%x', $start), strftime('%x', $end)), 'horde.message');
    header('Location: ' . Horde::applicationUrl('reports.php?dateselect=1', true));
    exit;
}

$csv = &Horde_Data::singleton('csv');
$csv->exportFile('rakim.csv', $data, true);
