<?php
/**
 * $Horde: rakim/emailForward.php,v 1.17 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once 'Horde/Text/Filter.php';

function forwardForm($question_id)
{
    global $db, $rakim, $title;

    $selectQuery = "SELECT * FROM rakim_emails
        WHERE email_id = " . (int)$question_id . "
        AND (email_status = 'claimed' OR email_status = 'replied' OR email_status = 'forwarded')
        AND email_user_uid = " . $db->quote(Auth::getAuth());

    Horde::logMessage($selectQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($selectQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    } elseif (!$result->numRows()) {
        echo '<span class="light">' . _("You are not allowed to forward this request.") . '</span>';
    } else {
        $email = $result->fetchRow(DB_FETCHMODE_ASSOC);
?>

<form method="post" action="emailForward.php" name="forward">
<?php Util::pformInput() ?>
<table border="0" cellpadding="2" cellspacing="0" align="center" width="100%">
<tr>
  <td class="header" colspan="2"><?php echo $title ?></td>
</tr>
<tr>
  <td width="100%" colspan="2" class="control">
   <table border="0" cellpadding="2" cellspacing="1" width="100%">
    <tr>
     <td nowrap="nowrap" width="10%" align="right" class="item0"><b><?php echo _("From") ?></b></td><td width="90%" class="item0"><?php echo htmlspecialchars($email['guest_email']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Organization") ?></b></td><td class="item1"><?php echo htmlspecialchars($rakim->getOrganization($email['guest_organization'])) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("User Type") ?></b></td><td class="item0"><?php echo htmlspecialchars($email['guest_type']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Question Category") ?></b></td><td class="item1"><?php echo htmlspecialchars($email['guest_question_category']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Request Received") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_asked']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'claimed' || $email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Claimed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_claimed']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Requested First Answered") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_answered']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Closed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_closed']) ?></td>
    </tr>
    <?php endif; ?>
    <?php endif; ?>
    <?php endif; ?>

    <tr>
     <td colspan="2" class="control">&nbsp;</td>
    </tr>

    <tr>
     <td colspan="2" class="control"><b><?php echo _("Original Question") ?></b></td>
    </tr>
    <tr>
     <td colspan="2" class="text"><blockquote><?php echo Text_Filter::filter($email['email_text'], 'text2html', array('parselevel' => TEXT_HTML_MICRO)) ?></blockquote></td>
    </tr>

    <tr>
     <td colspan="2" class="control">&nbsp;</td>
    </tr>

    <tr>
     <td align="right" class="item0"><b><?php echo _("Forward To") ?></b></td>
     <td class="item0"><input type="text" name="to" size="60" />&nbsp;<?php echo Horde::link('', _("Search my addresss book"), null, null, "window.open('" . Horde::applicationUrl('contacts.php') . "', 'contacts', 'toolbar=no,location=no,status=yes,scrollbars=yes,resizable=yes,width=600,height=300,left=100,top=100'); return false;") . Horde::img('contacts.png') ?></a></td>
    </tr>

   </table>
  </td>
</tr>

<tr>
  <td colspan="2">
    <input type="hidden" name="question_id" value="<?php echo $email['email_id'] ?>" />
    <input class="button" type="submit" name="forward" value="<?php echo _("Forward") ?>" />
    <input class="button" type="submit" name="close" value="<?php echo _("Forward and Close") ?>" />
    <input class="button" type="button" name="cancel" onclick = "window.location = '<?php echo Horde::applicationUrl('emailView.php?id=' . $email['email_id']) ?>';" value="<?php echo _("Back to this Email") ?>" />
  </td>
</tr>

</table>
</form>
<?php
    }
}

$question_id = Util::getPost('question_id');
if ($question_id) {
    $to = trim(Util::getPost('to'));

    if (!$to) {
        $notification->push(_("You must supply at least one recipient."), 'horde.error');
    } else {
        $forwardQuery = "UPDATE rakim_emails
            SET email_status = 'forwarded'
            WHERE email_id = " . (int)$question_id . "
                AND email_user_uid = " . $db->quote(Auth::getAuth()) . "
                AND (email_status = 'claimed' OR email_status = 'replied' OR email_status = 'forwarded')";

        $result = $db->query($forwardQuery);
        if (is_a($result, 'PEAR_Error')) {
            $notification->push(sprintf(_("There was an error forwarding the request: %s"), $result->getMessage()), 'horde.error');
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        } else {
            // Set the answered time if it hasn't yet been set.
            $timeQuery = 'UPDATE rakim_emails SET email_time_answered = ' . time() . ' WHERE email_time_answered IS NULL';
            $db->query($timeQuery);

            $selectQuery = "SELECT * FROM rakim_emails WHERE email_id = " . (int)$question_id . "
                        AND email_user_uid = " . $db->quote(Auth::getAuth()) . "
                        AND email_status = 'forwarded'";

            Horde::logMessage($selectQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

            $result = $db->query($selectQuery);
            if (is_a($result, 'PEAR_Error')) {
                $notification->push(sprintf(_("There was an error forwarding this request: %s"), $result->getMessage()), 'horde.error');
                Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
            } elseif (!$result->numRows()) {
                $notification->push(_("You are not allowed to forward this request."), 'horde.error');
            } else {
                require_once 'Horde/MIME.php';
                require_once 'Horde/MIME/Headers.php';
                require_once 'Horde/MIME/Message.php';
                require_once 'Horde/MIME/Part.php';

                $email = $result->fetchRow(DB_FETCHMODE_ASSOC);

                // Get the forwarder's email address.
                require_once 'Horde/Identity.php';
                $identity = &Identity::singleton();
                @list($user, $host) = @explode('@', $identity->getValue('from_addr'));
                $from = MIME::rfc822WriteAddress($user, $host, $identity->getValue('fullname'));

                // Write out the full guest email.
                @list($guser, $ghost) = @explode('@', $email['guest_email']);
                $guest_email = MIME::rfc822WriteAddress($guser, $ghost, $email['guest_name']);

                $message  = String::wrap(sprintf(_("This email has been forwarded to you by %s. You may reply directly to the user who asked the question, or access the original request here: %s"),
                                               $from, Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true, -1)));

                $message .= "\n\n-----------------------\n\n";
                $message .= sprintf(_("From:         %s\n"), $guest_email);
                $message .= sprintf(_("Organization: %s\n"), $rakim->getOrganization($email['guest_organization']));
                $message .= sprintf(_("Received:     %s\n"), strftime('%x %X', $email['email_time_asked']));
                $message .= "\n";
                $message .= String::wrap($email['email_text'], 70);

                $mime = &new MIME_Message();
                $body = &new MIME_Part('text/plain', $message);

                $mime->addPart($body);

                // Build the forward headers.
                $msg_headers = &new MIME_Headers();
                $msg_headers->addMessageIdHeader();
                $msg_headers->addHeader('Date', date('r'));
                $msg_headers->addHeader('From', $from);
                $msg_headers->addHeader('To', $to);
                $msg_headers->addHeader('Subject', sprintf(_("Forwarded Request (#%s)"), $email['email_id']));
                $msg_headers->addMIMEHeaders($mime);

                // Forward the request.
                $result = $mime->send($to, $msg_headers);
                if (is_a($result, 'PEAR_Error')) {
                    $notification->push(sprintf(_("An error occurred forwarding the request: %s"), $result->getMessage()), 'horde.error');
                } else {
                    $notification->push(_("The request was successfully forwarded."), 'horde.success');
                    if (Util::getFormData('close')) {
                        header('Location: ' . Util::addParameter(Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true), 'close', 1));
                    } else {
                        header('Location: ' . Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true));
                    }
                    exit;
                }
            }
        }
    }
}

$id = Util::getFormData('id', $question_id);
$title = sprintf(_("Forward Request %s to an external email account"), $id);
$notification->push('document.forward.to.focus();', 'javascript');
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';
forwardForm($id);
require $registry->get('templates', 'horde') . '/common-footer.inc';
