<?php
/**
 * $Horde: rakim/emailList.php,v 1.15 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

function echoRow($row)
{
    // Track alternating row colors.
    static $i;
    !isset($i) ? $i = 0 : $i++;

    echo '<tr class="item' . $i % 2 . '"><td>' . (int)$row['email_id'] . '</td><td>' . htmlspecialchars($row['guest_email']) . '</td><td>' . (!empty($row['organization_name']) ? htmlspecialchars($row['organization_name']) : _("No organization")) . '</td><td>' . htmlspecialchars($row['guest_type']) . '</td><td nowrap="nowrap">' . strftime('%x %X', $row['email_time_asked']) . '</td><td>' . htmlspecialchars($row['guest_question_category']) . '</td>';
    echo '<td width="40%">';
    $label = htmlspecialchars(substr($row['email_text'], 0, 80)) . ' ...</td>';
    echo Horde::link(Horde::applicationUrl('emailView.php?id=' . $row['email_id']), $label) . $label . '</a>';
    echo '</td><td class="' . htmlspecialchars($row['email_status']) . '">';

    if ($row['email_status'] == 'open') {
        echo _("Open");
    } elseif ($row['email_status'] == 'claimed') {
        echo _("Claimed");
    } elseif ($row['email_status'] == 'replied') {
        echo _("Replied");
    } elseif ($row['email_status'] == 'forwarded') {
        echo _("Forwarded");
    } elseif ($row['email_status'] == 'closed') {
        echo _("Closed");
    }

    echo '</td></tr>';
}

function showTable($result)
{
    global $title, $registry;

    $self = Horde::selfUrl();
    $aself = Util::addParameter($self, 'all', 1);
?>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tr>
  <td class="header"><?php echo $title ?>&nbsp;<?php echo Horde::link(Horde::selfUrl(true), _("Refresh")) . Horde::img('reload.png', _("Refresh"), '', $registry->getImageDir('horde')) ?></a></td>
  <td class="header" align="right">
  <span class="smallheader">
    <a href="<?php echo Util::addParameter($self, 'state', 'open') ?>"><?php echo _("Open Requests") ?></a> |
    <a href="<?php echo Util::addParameter($self, 'state', 'pending') ?>"><?php echo _("My Pending Requests") ?></a> |
    <a href="<?php echo Util::addParameter($self, 'state', 'closed') ?>"><?php echo _("My Closed Requests") ?></a>
<?php if (Auth::isAdmin('rakim:admin')): ?> |
    <a href="<?php echo Util::addParameter($aself, 'state', 'pending') ?>"><?php echo _("All Pending") ?></a> |
    <a href="<?php echo Util::addParameter($aself, 'state', 'closed') ?>"><?php echo _("All Closed") ?></a>
<?php endif; ?>
  </span>
  </td>
</tr>
<tr><td colspan="2" class="control"><table width="100%" border="0" cellpadding="2" cellspacing="1">
<tr>
<td class="item"><b>#</b></td>
<td class="item"><b><?php echo _("From") ?></b></td>
<td class="item"><b><?php echo _("Organization") ?></b></td>
<td class="item"><b><?php echo _("Type") ?></b></td>
<td class="selected"><b><?php echo _("Date") ?></b></td>
<td class="item"><b><?php echo _("Category") ?></b></td>
<td class="item"><b><?php echo _("Question") ?></b></td>
<td class="item"><b><?php echo _("Status") ?></b></td>
</tr>
<?php

    if ($result) {
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
            echoRow($row);
        }
    } else {
        echo '<td class="item0" colspan="8"><i>' . _("There are no matching emails.") . '</i></td>';
    }
    echo '</table></td></tr></table>';
}

function showOpenEmails()
{
    global $db;

    $openEmailsQuery = "SELECT * FROM rakim_emails
        LEFT JOIN rakim_organizations o ON o.organization_id = rakim_emails.guest_organization
        WHERE email_status = 'open'
        ORDER BY email_time_asked DESC";

    Horde::logMessage($openEmailsQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($openEmailsQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    } elseif ($result->numRows()) {
        showTable($result);
    } else {
        showTable(false);
    }
}

function showPendingEmails()
{
    global $db;

    $pendingEmailsQuery = "SELECT * FROM rakim_emails
        LEFT JOIN rakim_organizations o ON o.organization_id = rakim_emails.guest_organization
        WHERE (email_status = 'claimed' OR email_status = 'replied' OR email_status = 'forwarded')";

    if (!$_SESSION['rakim']['email_all']) {
        $pendingEmailsQuery .= ' AND email_user_uid = ' . $db->quote(Auth::getAuth());
    }

    $pendingEmailsQuery .= " ORDER BY email_time_asked DESC";

    Horde::logMessage($pendingEmailsQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($pendingEmailsQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    } elseif ($result->numRows()) {
        showTable($result);
    } else {
        showTable(false);
    }
}

function showClosedEmails()
{
    global $db;

    $closedEmailsQuery = "SELECT * FROM rakim_emails
        LEFT JOIN rakim_organizations o ON o.organization_id = rakim_emails.guest_organization
        WHERE email_status = 'closed'";

    if (!$_SESSION['rakim']['email_all']) {
        $closedEmailsQuery .= ' AND email_user_uid = ' . $db->quote(Auth::getAuth());
    }

    $closedEmailsQuery .= ' ORDER BY email_time_asked DESC';

    Horde::logMessage($closedEmailsQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($closedEmailsQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    } elseif ($result->numRows()) {
        showTable($result);
    } else {
        showTable(false);
    }
}

if (empty($_SESSION['rakim']['email_state'])) {
    $_SESSION['rakim']['email_state'] = 'open';
}
if (empty($_SESSION['rakim']['email_all'])) {
    $_SESSION['rakim']['email_all'] = false;
}

$state = Util::getFormData('state', $_SESSION['rakim']['email_state']);
$_SESSION['rakim']['email_state'] = $state;
if (Auth::isAdmin('rakim:admin') && Util::getFormData('state')) {
    $_SESSION['rakim']['email_all'] = (bool)Util::getFormData('all');
}

if ($state == 'pending') {
    if ($_SESSION['rakim']['email_all']) {
        $title = _("All Pending Email Requests");
    } else {
        $title = _("My Pending Email Requests");
    }
} elseif ($state == 'closed') {
    if ($_SESSION['rakim']['email_all']) {
        $title = _("All Closed Email Requests");
    } else {
        $title = _("My Closed Email Requests");
    }
} else {
    $title = _("All Open Email Requests");
}

$refresh_time = 360;
$refresh_url = Horde::selfUrl(true);
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';

if ($state == 'pending') {
    showPendingEmails();
} elseif ($state == 'closed') {
    showClosedEmails();
} elseif ($state == 'all') {
    showAllEmails();
} else {
    showOpenEmails();
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
