<?php
/**
 * $Horde: rakim/guest/email.php,v 1.15 2004/11/22 20:04:36 chuck Exp $
 */

// Never require authentication to send an email, since that would
// freeze out someone who needed to ask about account problems.
@define('AUTH_HANDLER', true);
@define('RAKIM_BASE', dirname(__FILE__) . '/..');
require_once RAKIM_BASE . '/lib/base.php';

function emailForm($guestName = '', $guestEmail = '', $guestQuestion = '', $guestOrg = 0, $guestType = '', $qCat = '')
{
    global $rakim, $conf, $notification;

    ?>
<form name="question" action="email.php" method="post">
<?php Util::pformInput() ?>
<input type="hidden" name="submitted" value="1">

<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
  <td align="center" class="header" colspan="2"><?php echo _("Ask your question via email") ?></td>
</tr>
</table>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr>
  <td width="50%" align="right" class="light"><b><?php echo _("Your name:") ?></b></td>
  <td width="50%"><input type="text" name="guestNameEntered" size="35" value="<?php echo htmlspecialchars($guestName) ?>" /></td>
</tr>
<tr>
  <td class="light" align="right"><b><?php echo _("Your email address:") ?></b></td>
  <td><input type="text" name="guestEmailEntered" size="35" value="<?php echo htmlspecialchars($guestEmail) ?>" /></td>
</tr>

<?php if ($conf['guest']['log_type'] == 'email' || $conf['guest']['log_type'] == 'both'): ?>
<tr>
  <td class="light" valign="top" align="right"><b><?php echo _("You are:") ?>&nbsp;</b></td>
  <td valign="top"><select name="guest_type" /><?php foreach ($conf['guest']['user_types'] as $type) echo '<option value="' . htmlspecialchars($type) . '"' . ($type == $guestType ? ' selected="selected"' : '') . '>' . htmlspecialchars($type) . '</option>'; ?></select></td>
</tr>
<?php endif; ?>

<?php $orgs = $rakim->getOrganizations(); if (!count($orgs) || $conf['guest']['log_organization'] == 'none' || $conf['guest']['log_organization'] == 'chat'): ?>
<input type="hidden" name="guest_organization" value="<?php echo (int)$guestOrg ?>" />
<?php elseif (count($orgs) == 1): ?>
<input type="hidden" name="guest_organization" value="<?php echo ($guestOrg ? $guestOrg : (int)key($orgs)) ?>" />
<?php else: ?>
<tr>
  <td class="light" align="right"><b><?php echo _("Organization:") ?></b>&nbsp;</td>
  <td>
    <select name="guest_organization">
  <?php foreach ($orgs as $id => $name): ?>
      <option value="<?php echo (int)$id ?>"<?php if ($id == $guestOrg) echo ' selected="selected"' ?>><?php echo htmlspecialchars($name) ?></option>
  <?php endforeach; ?>
    </select>
  </td>
</tr>
<?php endif; ?>

<?php if ($conf['guest']['log_category'] == 'email' || $conf['guest']['log_category'] == 'both'): ?>
<tr>
  <td class="light" valign="top" align="right"><b><?php echo _("What kind of question is this?") ?>&nbsp;</b></td>
  <td valign="top"><select name="question_category" /><?php foreach ($conf['guest']['question_categories'] as $category) echo '<option value="' . htmlspecialchars($category) . '"' . ($qCat == $category ? ' selected="selected"' : '') . '>' . htmlspecialchars($category) . '</option>'; ?></select></td>
</tr>
<?php endif; ?>

<tr>
  <td>&nbsp;</td>
</tr>

<tr>
  <td class="light" align="right" valign="top"><b><?php echo _("Enter your question:") ?></b></td>
  <td><textarea name="guestQuestionEntered" rows="7" cols="50"><?php echo htmlspecialchars($guestQuestion) ?></textarea></td>
</tr>

<tr>
  <td></td>
  <td><input class="button" type="submit" name="send" value="<?php echo _("Send your question") ?>" /></td>
</tr>
</table>

</form>

<script language="JavaScript" type="text/javascript">
<!--

if (document.question.guestNameEntered.value == "") {
    document.question.guestNameEntered.focus();
} else if (document.question.guestEmailEntered.value == "") {
    document.question.guestEmailEntered.focus();
} else {
    document.question.guestQuestionEntered.focus();
}

// -->
</script>
    <?php
}

if (Util::getFormData('done')) {
    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/menu.inc';

} elseif (!Util::getFormData('submitted')) {
    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/menu.inc';
    emailForm(Util::getPost('guestNameEntered'), Util::getPost('guestEmailEntered'), Util::getPost('guestQuestionEntered'), Util::getPost('guest_organization'), Util::getPost('guest_type'), Util::getPost('question_category'));

} elseif (!Util::getPost('guestEmailEntered') || !Util::getPost('guestQuestionEntered')) {
    $notification->push(_("Either you entered a blank email address or a blank question. Please correct the problem and try again."), 'horde.error');

    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/menu.inc';
    emailForm(Util::getPost('guestNameEntered'), Util::getPost('guestEmailEntered'), Util::getPost('guestQuestionEntered'), Util::getPost('guest_organization'), Util::getPost('guest_type'), Util::getPost('question_category'));

} else {
    if (!isset($_SESSION['rakim']['guest_id'])) {
        $_SESSION['rakim']['guest_id'] = 0;
    }

    $eid = $db->nextId('rakim_emails');
    if (is_a($eid, 'PEAR_Error')) {
        Horde::logMessage($eid, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(_("There was an error sending your question. Please try again, or contact your system administrator."), 'horde.error');
    } else {
        $insertQuery = sprintf('INSERT INTO rakim_emails (email_id, guest_id, guest_session_id, guest_name, guest_email,' .
                               ' guest_organization, guest_type, guest_question_category, guest_remote_addr, guest_user_agent, email_text, email_time_asked)' .
                               ' VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)',
                               (int)$eid,
                               (int)$_SESSION['rakim']['guest_id'],
                               $db->quote(session_id()),
                               $db->quote(trim(Util::getPost('guestNameEntered'))),
                               $db->quote(trim(Util::getPost('guestEmailEntered'))),
                               (int)Util::getPost('guest_organization', 1),
                               $db->quote(Util::getPost('guest_type')),
                               $db->quote(Util::getPost('question_category')),
                               $db->quote($_SERVER['REMOTE_ADDR']),
                               $db->quote($_SERVER['HTTP_USER_AGENT']),
                               $db->quote(Util::getPost('guestQuestionEntered')),
                               time());

        Horde::logMessage($insertQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($insertQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
            $notification->push(_("There was an error sending your question. Please try again, or contact your system administrator."), 'horde.error');
        } else {
            $notification->push(sprintf(_("Your question has been sent to the support service. A response will be sent to %s."), htmlspecialchars(Util::getPost('guestEmailEntered'))), 'horde.success');
        }
    }

    header('Location: ' . Horde::applicationUrl('guest/email.php?done=1', true));
    exit;
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
