<?php
/**
 * $Horde: rakim/guest/monitor.php,v 1.9 2004/10/19 00:46:04 chuck Exp $
 */

define('RAKIM_BASE', dirname(__FILE__) . '/..');
require_once RAKIM_BASE . '/lib/base.php';

// Bad session.
if (empty($_SESSION['rakim']['guest_name']) || empty($_SESSION['rakim']['guest_id'])) {
    header('Location: ' . Horde::applicationUrl('guest/', true));
    exit;
}

header('Expires: -1');
header('Pragma: no-cache');
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');

function updateRefreshTime()
{
    global $db;

    $updateRefreshTimeQuery = 'UPDATE rakim_guests SET guest_refresh_time = ' . time() . ' WHERE guest_id = ' . (int)$_SESSION['rakim']['guest_id'];
    Horde::logMessage($updateRefreshTimeQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $refreshResult = $db->query($updateRefreshTimeQuery);
    if (is_a($refreshResult, 'PEAR_Error')) {
        Horde::logMessage($refreshResult, __FILE__, __LINE__, PEAR_LOG_ERR);
    }
}

function countCurrBuffer()
{
    global $db;

    $countCurrBufferQuery = "SELECT count(*) AS countBuffer FROM rakim_messages
        WHERE guest_id = " . $_SESSION['rakim']['guest_id'] . " AND message_time >= '" . $_SESSION['rakim']['login_time'] . "'";

    Horde::logMessage($countCurrBufferQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $countBuffer = $db->getOne($countCurrBufferQuery); 
    if (is_a($countBuffer, 'PEAR_Error')) {
        Horde::logMessage($countBuffer, __FILE__, __LINE__, PEAR_LOG_ERR);
        return 0;
    } else {
        return $countBuffer;
    }
}

updateRefreshTime();
$countBuffer = countCurrBuffer();

require RAKIM_TEMPLATES . '/common-header.inc';
?>

<script language="JavaScript" type="text/javascript">
<?php

if (!isset($_SESSION['rakim']['prevBuffer'])) {
    $_SESSION['rakim']['prevBuffer'] = 0;
}
if ($_SESSION['rakim']['prevBuffer'] != $countBuffer) {
    $_SESSION['rakim']['delta'] = $countBuffer - $_SESSION['rakim']['prevBuffer'];
    ?>
    window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('guest/messages.php') ?>';", 0);
    <?php

    if ($_SESSION['rakim']['guest_status'] == 'waiting' && ($countBuffer > 1)) {
        $_SESSION['rakim']['guest_status'] = 'active';
        ?>
        window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('guest/input.php') ?>';", 0);
        <?php
    }
}

if ($_SESSION['rakim']['guest_status'] == 'waiting') {
    $status = $db->getOne('SELECT queue_status FROM rakim_queues WHERE guest_id = ' . (int)$_SESSION['rakim']['guest_id']);
    if ($status == 'active') {
        $_SESSION['rakim']['guest_status'] = 'active';
        ?>
        window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('guest/messages.php') ?>';", 0);
        window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('guest/input.php') ?>';", 0);
        <?php
    } elseif (empty($_SESSION['rakim']['shownWarning'])) {
        $delta = time() - $_SESSION['rakim']['login_time'];

        if ($delta > $conf['guest']['wait']) {
            $_SESSION['rakim']['shownWarning'] = 1;
        ?>
        window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('guest/messages.php') ?>';", 0);
        <?php
        }
    }
}

?>
window.setTimeout("window.location.reload(true);", 5000);
</script>
<?php

$_SESSION['rakim']['prevBuffer'] = $countBuffer;
require $registry->get('templates', 'horde') . '/common-footer.inc';
