<?php
/**
 * $Horde: rakim/home.php,v 1.12 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

// Categorize sessions if requested.
if (($ids = Util::getFormData('guest_ids')) !== null) {
    $qtypes = Util::getFormData('qtypes');
    $resolutions = Util::getFormData('resolution');
    $i = 0;
    foreach ($ids as $id) {
        if (empty($qtypes[$id]) ||
            !is_array($qtypes[$id]) ||
            !count($qtypes[$id]) ||
            empty($resolutions[$id])) {
            continue;
        }

        $statusQuery = 'UPDATE rakim_queues SET queue_resolution = ' . $db->quote($resolutions[$id]) . ', queue_question_types = ' . $db->quote(implode(', ', $qtypes[$id])) . ' WHERE guest_id = ' . (int)$id . ' AND user_uid = ' . $db->quote(Auth::getAuth()) . ' AND queue_resolution IS NULL';
        Horde::logMessage($statusQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($statusQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        } else {
            $i++;
        }
    }

    if ($i == 1) {
        $notification->push(_("Succesfully categorized 1 session."), 'horde.success');
    } elseif ($i) {
        $notification->push(sprintf(_("Succesfully categorized %s sessions."), $i), 'horde.success');
    }
}

$title = _("Home");
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';

$result = $db->query('SELECT queue_id, guest_id FROM rakim_queues WHERE queue_status = \'exit\' AND user_uid = ' . $db->quote(Auth::getAuth()) . ' AND queue_resolution IS NULL');
if (is_a($result, 'PEAR_Error')) {
    Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
} elseif ($result->numRows()) {
    require RAKIM_TEMPLATES . '/home/categorize.inc';
}

require RAKIM_TEMPLATES . '/home/home.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
