<?php

require_once 'Horde/Form.php';

/**
 * Date range for report generation.
 *
 * $Horde: rakim/lib/DateRange.php,v 1.7 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Chuck Hagenbuch <chuck@horde.org>
 * @version $Revision: 1.7 $
 * @package Rakim
 */
class DateRangeForm extends Horde_Form {

    var $_useFormToken = false;

    function DateRangeForm(&$vars, $title = '', $prefix = '')
    {
        parent::Horde_Form($vars, $title);

        $this->_submit = _("Generate Report");

        $start = &$this->addVariable(_("Start date"), $prefix . '_report_start', 'monthdayyear', false, false, null, array(null, date('Y') + 3, true, 3));
        $end = &$this->addVariable(_("End date"), $prefix . '_report_end', 'monthdayyear', false, false, null, array(null, date('Y') + 3, true, 3));

        $start->setDefault(time());
        $end->setDefault(time());
    }

}

class ChatRangeForm extends DateRangeForm {

    function ChatRangeForm(&$vars)
    {
        parent::DateRangeForm($vars, _("Full CSV report of chat activity"), 'chat');
    }

}

class EmailRangeForm extends DateRangeForm {

    function EmailRangeForm(&$vars)
    {
        parent::DateRangeForm($vars, _("Full CSV report of email activity"), 'email');
    }

}
