<?php

$graphs = array('session_doy' => _("Chat activity by day of the year"),
                'session_dow' => _("Chat activity by day of the week"),
                'session_month' => _("Chat activity by month"),
                'session_week' => _("Chat activity by week"),
                'session_hour' => _("Chat activity by hour"),
                'email_doy' => _("Email activity by day of the year"),
                'email_dow' => _("Email activity by day of the week"),
                'email_month' => _("Email activity by month"),
                'email_week' => _("Email activity by week"),
                'email_hour' => _("Email activity by hour"));

/**
 * Class for Rakim report generation.
 *
 * $Horde: rakim/lib/Reports.php,v 1.5 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author Chuck Hagenbuch <chuck@horde.org>
 * @version $Revision: 1.5 $
 * @package Rakim
 */
class Rakim_Reports {

    function getQuery($graph)
    {
        if (strstr($graph, 'session')) {
            $table = 'rakim_archived_sessions';
        } else {
            $table = 'rakim_archived_emails';
        }
        return 'SELECT count(*) AS count, ' . $graph . ' AS var' .
               ' FROM ' . $table . ' GROUP BY var ORDER BY var';
    }

    function formatData($graph, &$data)
    {
        $trans = false;
        switch ($graph) {
        case 'email_dow':
        case 'session_dow':
            $trans = array(
                0 => _("Sunday"),
                1 => _("Monday"),
                2 => _("Tuesday"),
                3 => _("Wednesday"),
                4 => _("Thursday"),
                5 => _("Friday"),
                6 => _("Saturday"));
            break;

        case 'email_month':
        case 'session_month':
            $trans = array(
                1  => _("January"),
                2  => _("February"),
                3  => _("March"),
                4  => _("April"),
                5  => _("May"),
                6  => _("June"),
                7  => _("July"),
                8  => _("August"),
                9  => _("September"),
                10 => _("October"),
                11 => _("November"),
                12 => _("December"));
            break;
        }

        if ($trans) {
            $keys = array_keys($data);
            foreach ($keys as $key) {
                $data[$key]['var'] = $trans[$data[$key]['var']];
            }
        }
    }

}
