<?php
/**
 * $Horde: rakim/lib/base.php,v 1.15 2004/10/19 00:46:04 chuck Exp $
 *
 * Rakim base inclusion file.
 *
 * This file brings in all of the dependencies that every Rakim script
 * will need and sets up objects that all scripts use.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    @define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
if (Util::nonInputVar('session_control') == 'none') {
    $registry = &Registry::singleton(HORDE_SESSION_NONE);
} else {
    $registry = &Registry::singleton();
}
if (is_a(($pushed = $registry->pushApp('rakim', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect(); 
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
@define('RAKIM_TEMPLATES', $registry->get('templates'));

// Find the base file path of Rakim.
@define('RAKIM_BASE', dirname(__FILE__) . '/..');

// Rakim base library.
require_once RAKIM_BASE . '/lib/Rakim.php';

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Check for proper authentication for the kind of page we're on:
Rakim::checkAuthentication();

// Help.
require_once 'Horde/Help.php';

$GLOBALS['rakim'] = &Rakim_Driver::singleton();
$GLOBALS['db'] = $GLOBALS['rakim']->_db;
