<?php
/**
 * $Horde: rakim/login.php,v 1.13 2004/10/19 00:46:03 chuck Exp $
 */

@define('AUTH_HANDLER', true);
@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once 'Horde/Secret.php';
require RAKIM_BASE . '/config/auth.php';

// Make sure we're using an external authentication backend.
if ($conf['authentication']['tech'] != 'external') {
    require RAKIM_BASE . '/home.php';
    exit;
}

/* Initialize the Auth credentials key. */
Secret::setKey('auth');

/* Get an Auth object. */
$auth = &Auth::singleton($conf['rakim_tech_auth']['driver']);

/* Get parameters. */
$logout_reason = $auth->getLogoutReason();
$url_param = Util::getFormData('url');

if ($logout_reason == AUTH_REASON_LOGOUT) {
    $language = isset($prefs) ? $prefs->getValue('language') : NLS::select();

    $entry = sprintf('User %s [%s] logged out of Rakim',
                     Auth::getAuth(), $_SERVER['REMOTE_ADDR']);
    Horde::logMessage($entry, __FILE__, __LINE__, PEAR_LOG_NOTICE);
    Auth::clearAuth('rakim_techs');
    session_destroy();

    Horde::setupSessionHandler();
    @session_start();

    NLS::setLang($language);

    /* Hook to preselect the correct language in the widget. */
    $_GET['new_lang'] = $language;
}

if (isset($_POST['horde_user']) && isset($_POST['horde_pass'])) {
    /* Destroy any existing session on login and make sure to use a
     * new session ID, to avoid session fixation issues. */
    Horde::getCleanSession();

    /* If authentication is successful, make sure to authenticate to
     * the 'rakim_techs' realm, not to general Horde
     * authentication. */
    if ($auth->authenticate(Util::getPost('horde_user'),
                            array('password' => Util::getPost('horde_pass')),
                            true, 'rakim_techs')) {
        $entry = sprintf('Login success for %s [%s] to Rakim',
                         Auth::getAuth(), $_SERVER['REMOTE_ADDR']);
        Horde::logMessage($entry, __FILE__, __LINE__, PEAR_LOG_INFO);

        if ($url_param) {
            header('Location: ' . Horde::url(Util::removeParameter($url_param, session_name()), true));
        } else {
            header('Location: ' . Horde::applicationUrl('index.php', true));
        }
        exit;
    } else {
        $entry = sprintf('FAILED LOGIN for %s [%s] to Rakim',
                         Util::getFormData('horde_user'), $_SERVER['REMOTE_ADDR']);
        Horde::logMessage($entry, __FILE__, __LINE__, PEAR_LOG_ERR);
    }
}

$reason = $auth->getLogoutReasonString();

if (Auth::isAuthenticated('rakim_techs')) {
    require HORDE_BASE . '/home.php';
    exit;
}

/* Build the <select> widget containing the available languages. */
if (!$prefs->isLocked('language')) {
    $_SESSION['horde_language'] = NLS::select();
    $langs = '<select name="new_lang" onchange="selectLang()">';
    foreach ($nls['languages'] as $key => $val) {
        $sel = ($key == $_SESSION['horde_language']) ? ' selected="selected"' : '';
        $langs .= "<option value=\"$key\"$sel>$val</option>";
    }
    $langs .= '</select>';
}

$title = _("Log in");
$notification->push('setFocus()', 'javascript');

require RAKIM_TEMPLATES . '/common-header.inc';
$notification->notify(array('listeners' => 'status'));
require RAKIM_TEMPLATES . '/login/login.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
