<?php
/**
 * $Horde: rakim/messages.php,v 1.16 2004/10/19 00:46:03 chuck Exp $
 */

function showPersonnelBuffer()
{
    global $db;

    $getPMessageQuery = "SELECT user_uid_sender AS sender_id, user_uid_recipient AS recipient_id, pmessage_text AS message, pmessage_push as push FROM rakim_personnel_messages
        WHERE (user_uid_recipient = '0' OR user_uid_recipient = " . $db->quote(Auth::getAuth()) . " OR user_uid_sender = " . $db->quote(Auth::getAuth()) . ")
            AND pmessage_time >= '" . Rakim::getLastLogin() . "'
        ORDER BY pmessage_time DESC";

    Horde::logMessage($getPMessageQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $pmessages = $db->query($getPMessageQuery); 
    if (is_a($pmessages, 'PEAR_Error')) {
        Horde::logMessage($pmessages, __FILE__, __LINE__, PEAR_LOG_ERR);
        return false;
    } else {
        $i = 1;
        while ($row = $pmessages->fetchRow(DB_FETCHMODE_ASSOC)) {
            $style = '';
            if (!empty($row['recipient_id'])) {
                $label = $row['sender_id'] . ' to ' . $row['recipient_id'];
                if ($row['recipient_id'] == Auth::getAuth()) {
                    $class = 'incoming';
                } else {
                    $class = 'outgoing';
                }
            } else {
                $label = $row['sender_id'];
                if ($row['sender_id'] == Auth::getAuth()) {
                    $class = 'mine';
                } else {
                    $class = 'other';
                    $style = ' style="color:' . Rakim::getTechColor($row['sender_id']) . ';"';
                }
            }
            echo '<div class="' . $class . '"' . $style . '><b>' . htmlspecialchars($label) . ': </b>';
            if ($row['push'] == 't') {
                echo Horde::link($row['message'], _("Please follow this URL"), '', '_blank') . htmlspecialchars($row['message']) . '</a>';
            } else {
                echo htmlspecialchars($row['message']);
            }
            echo '</div>';

            if (!isset($_SESSION['rakim']['techDelta']) ||
                $i == $_SESSION['rakim']['techDelta']) {
                echo '<hr />';
            }

            $i++;
        }
    }
}

function showGuestBuffer()
{
    global $db;

    $guestNumber = $_SESSION['rakim']['guestNumber'];
    if (empty($guestNumber)) {
        return false;
    }

    $getCurrBufferQuery = "SELECT * FROM rakim_messages
        WHERE guest_id = " . $_SESSION['rakim']['guest_ids'][$guestNumber] . "
        ORDER BY message_time DESC";

    Horde::logMessage($getCurrBufferQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $currBuffer = $db->query($getCurrBufferQuery); 
    if (is_a($currBuffer, 'PEAR_Error')) {
        Horde::logMessage($currBuffer, __FILE__, __LINE__, PEAR_LOG_ERR);
    } else {
        $i = 1;
        while ($row = $currBuffer->fetchRow(DB_FETCHMODE_ASSOC)) {
            $style = '';
            if (empty($row['user_uid']) || $row['user_uid'] == 'NULL') {
                $class = 'incoming';
            } elseif ($row['user_uid'] == Auth::getAuth()) {
                $class = 'mine';
            } else {
                $class = 'other';
                $style = ' style="color:' . Rakim::getTechColor($row['user_uid']) . ';"';
            }

            echo "<div class=\"$class\"$style><b>" . htmlspecialchars(empty($row['message_sender']) ? $row['user_uid'] : $row['message_sender']) . ': </b>';
            if ($row['message_push'] == 't') {
                echo Horde::link($row['message_text'], _("Please follow this URL"), '', '_blank') . htmlspecialchars($row['message_text']) . '</a>';
            } else {
                echo htmlspecialchars($row['message_text']);
            }
            echo '</div>';

            if (!isset($_SESSION['rakim']['guestDelta'][$_SESSION['rakim']['guestNumber']]) ||
                $i == $_SESSION['rakim']['guestDelta'][$_SESSION['rakim']['guestNumber']]) {
                echo '<hr />';
            }
            $i++;
        }
    }
}

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

if (Util::getGet('guestNumber') !== null) { 
    $_SESSION['rakim']['guestNumber'] = Util::getGet('guestNumber');
} elseif (empty($_SESSION['rakim']['guestNumber'])) {
    $_SESSION['rakim']['guestNumber'] = 0;
}

require RAKIM_TEMPLATES . '/common-header.inc';

if ($_SESSION['rakim']['guestNumber'] &&
    !empty($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']])) {
    showGuestBuffer();
} else {
    $_SESSION['rakim']['guestNumber'] = 0;
    showPersonnelBuffer();
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
