<?php
/**
 * $Horde: rakim/plot.php,v 1.11 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once RAKIM_BASE . '/lib/Reports.php';
require_once 'Horde/Graph.php';

if (!Auth::isAdmin('rakim:admin')) {
    Horde::authenticationFailureRedirect();
}

$graph = Util::getFormData('graph');
if (empty($graphs[$graph])) {
    exit;
}

$query = Rakim_Reports::getQuery($graph);
Horde::logMessage($query, __FILE__, __LINE__, PEAR_LOG_DEBUG);

$data = $db->getAll($query, DB_FETCHMODE_ASSOC);
if (is_a($data, 'PEAR_Error')) {
    Horde::logMessage($data, __FILE__, __LINE__, PEAR_LOG_ERR);
    exit;
}
if (count($data) == 0) {
    echo _("No data to display");
    exit;
}

Rakim_Reports::formatData($graph, $data);

if (Util::getFormData('tabbed')) {
    $browser->downloadHeaders('rakim-' . $graph . '.xls', 'application/xlc');
    echo _("Column") . "\t" . _("Sessions") . "\n\n";
    foreach ($data as $row) {
        echo $row['var'] . "\t" . $row['count'] . "\n";
    }
} else {
    $xdata = array();
    $ydata = array();
    foreach ($data as $row) {
        $xdata[] = $row['var'];
        $ydata[] = $row['count'];
    }

    // Define the object.
    $plot = &new Horde_Graph(array('width' => 580, 'height' => 480, 'temp' => Horde::getTempDir()));
    $plot->addXData($xdata);
    $plot->set('offsetGridX', .5);
    $plot->set('title', $graphs[$graph]);
    $plot->addPlot('bar', array('color' => 'blue', 'dataset' => $plot->addYData($ydata)));
    $plot->draw();
}
