<?php
/**
 * $Horde: rakim/queue.php,v 1.27 2004/10/19 00:46:03 chuck Exp $
 */

@ignore_user_abort(true);
define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

header('Expires: -1');
header('Pragma: no-cache');
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');

function outputQueue()
{
    global $db, $prefs, $rakim;

    $getQueueQuery = "SELECT g.guest_id, g.guest_name, g.guest_remote_addr, g.guest_type, g.guest_question_category,
                g.guest_initial_question, g.guest_organization, q.referrer_user_uid, q.queue_id, q.user_uid, q.queue_status, g.guest_entry_page,
            g.guest_login_time,
            g.guest_referral_time 
        FROM rakim_guests g, rakim_queues q
        WHERE (q.user_uid IS NULL OR q.user_uid = " . $db->quote(Auth::getAuth()) . ")
            AND (q.queue_status = 'waiting' OR q.queue_status = 'referral' OR q.queue_status = 'invite')
            AND g.guest_id = q.guest_id
            AND g.guest_logoff_time IS NULL
            AND (q.referrer_user_uid IS NULL OR q.referrer_user_uid != " . $db->quote(Auth::getAuth()) . ')';

    Horde::logMessage($getQueueQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($getQueueQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        echo '<table border="0" width="100%"><tr><td class="item"><b>' . _("There are no guests waiting in the queue.") . '</b></td></tr></table>';
    } elseif ($result->numRows()) {
        $now = time();
        $count = $result->numRows();

        if ($prefs->getValue('ring')): ?>
            <embed type="audio/x-wav" src="resources/ring.wav" autostart="true" hidden="true" loop="<?php echo ($prefs->getValue('ring') == 'loop') ? 'true' : 'false' ?>"></embed>
        <?php endif; ?>
        <table border="0" cellpadding="1" cellspacing="0" width="100%">
          <tr>
            <td class="header"><span class="smallheader"><?php if ($count == 1) echo _("1 guest waiting"); else printf(_("%s guests waiting"), count($result->numRows())); ?></span></td>
          </tr>
          <tr>
            <td class="control">
              <table border="0" cellspacing="1" cellpadding="1" width="100%">
        <?php
        $i = 1;
        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
            $class = 'item0';
            if ($row['queue_status'] == 'invite') {
                $class = 'open';
                $label = _("Invite");
            } elseif ($row['queue_status'] == 'referral') {
                $class = 'selected';
                $label = _("Referral");
            } else {
                $label = _("New");
            }

            echo '<tr valign="top"><td valign="top" class="' . $class . '">';
            echo '<form action="queue.php" method="post">' . Util::formInput() . '<input type="hidden" name="queue_id" value="' . htmlspecialchars($row['queue_id']) . '" /><input type="submit" class="button" name="submit" value="' . htmlspecialchars($label) . '" /></form></td>';
            echo '<td class="item0">' . htmlspecialchars($row['guest_name']) . '<br />' . htmlspecialchars($row['guest_remote_addr']) . '<br />' . $rakim->getOrganization($row['guest_organization']) . '<br />';
            if (!empty($row['guest_type'])) {
                echo htmlspecialchars($row['guest_type']) . '<br />';
            }
            if (!empty($row['guest_question_category'])) {
                echo htmlspecialchars($row['guest_question_category']) . '<br />';
            }
            if ($row['guest_entry_page'] == _("No referring page")) {
                echo _("No referring page");
            } else {
                echo '<a href="' . htmlspecialchars($row['guest_entry_page']) . '" target="_blank">' . htmlspecialchars($row['guest_entry_page']) . '</a>';
            }
            echo '</td>';

            if ($row['guest_referral_time']) {
                $waiting = $now - $row['guest_referral_time'];
            } else {
                $waiting = $now - $row['guest_login_time'];
            }
            echo '<td class="item0"><form><script language="JavaScript">ID[' . $i . "] = window.setTimeout(\"UpdateTimer($waiting, $i)\", 1000);</script><input type=\"text\" name=\"timer\" value=\"$waiting\" size=\"8\" />" . _("sec") . '</form></td></tr>';
            echo '<tr><td class="' . $class . '">&nbsp;</td><td class="item1" colspan="2">' . htmlspecialchars($row['guest_initial_question']) . '</td></tr>';
            $i = $i + 2;
        }
        ?>
        </table></td></tr></table>
        <?php
    } else {
        echo '<table border="0" width="100%"><tr><td class="item"><b>' . _("There are no guests waiting in the queue.") . '</b></td></tr></table>';
    }
}

function answerGuest()
{
    global $db;

    $setActiveQuery = "UPDATE rakim_queues SET queue_status = 'active', queue_active_time = " . time() . ", user_uid = " . $db->quote(Auth::getAuth()) . "
    WHERE queue_id = " . Util::getPost('queue_id') . " 
        AND (user_uid IS NULL OR user_uid = " . $db->quote(Auth::getAuth()) . ")
        AND queue_status != 'active'";

    Horde::logMessage($setActiveQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($setActiveQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        return false;
    } elseif ($db->affectedRows()) {
        $getGuestQuery = "SELECT q.guest_id AS guest_id, g.guest_name AS guest_name, g.guest_remote_addr AS remote_addr, g.guest_organization AS guest_organization, g.guest_entry_page as entry_page, g.guest_user_agent AS user_agent
        FROM rakim_guests g, rakim_queues q
        WHERE g.guest_id = q.guest_id
        and q.queue_id = " . (int)Util::getPost('queue_id');

        Horde::logMessage($getGuestQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($getGuestQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        } elseif ($result->numRows()) {
            $row = $result->fetchRow(DB_FETCHMODE_ASSOC);

            // Some of these arrays won't be set for the 0 (support)
            // queue, so calculate the common index for all of them.
            $guestNumber = isset($_SESSION['rakim']['queue_ids']) ?
                count($_SESSION['rakim']['queue_ids']) : 1;

            $_SESSION['rakim']['queue_ids'][$guestNumber] = Util::getPost('queue_id');
            $_SESSION['rakim']['guest_ids'][$guestNumber] = $row['guest_id'];
            $_SESSION['rakim']['guest_names'][$guestNumber] = $row['guest_name'];
            $_SESSION['rakim']['guest_remote_addrs'][$guestNumber] = $row['remote_addr'];
            $_SESSION['rakim']['guest_organizations'][$guestNumber] = $row['guest_organization'];
            $_SESSION['rakim']['entry_pages'][$guestNumber] = $row['entry_page'];
            $_SESSION['rakim']['user_agents'][$guestNumber] = $row['user_agent'];

            return $guestNumber;
        }
    } else {
        echo "<script language=\"JavaScript\">alert('" . addslashes(_("This call has already been answered.")) . "')</script>";
        return false;
    }
}

require RAKIM_TEMPLATES . '/common-header.inc';

$queue_id = Util::getPost('queue_id');
if ($queue_id) {
    $guestNumber = answerGuest();
    if ($guestNumber) {
        $_SESSION['rakim']['guestNumber'] = $guestNumber;
        $_SESSION['rakim']['tabReload'] = time();
        @session_write_close();

        if ($prefs->getValue('guest_greeting')) {
            sendGuestMessage($prefs->getValue('guest_greeting'), $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']], 'f', 'f');
        }
    ?>
    <script language="JavaScript" type="text/javascript">
    window.setTimeout("top.rakim_tabs.location.href = '<?php echo Horde::applicationUrl('tabs.php') ?>'", 0);
    window.setTimeout("top.rakim_monitor.location.href = '<?php echo Horde::applicationUrl('monitor.php?guestNumber=' . $guestNumber, true) ?>'", 0);
    window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('messages.php?guestNumber=' . $guestNumber, true) ?>'", 0);
    window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('input.php') ?>'", 0);
    </script>
    <?php
    }
}
?>

<script language="JavaScript" type="text/javascript">
var ID = new Array();
function UpdateTimer(start, i)
{
    start++;

    document.forms[i].timer.value = start;
    ID[i] = window.setTimeout("UpdateTimer(" + start + "," + i + ");", 1000);
}
</script>

<p><?php outputQueue() ?></p><?php

require $registry->get('templates', 'horde') . '/common-footer.inc';
