<?php
/**
 * $Horde: rakim/refer.php,v 1.17 2004/10/19 00:46:03 chuck Exp $
 */

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

function referGuest($guest_id = 0, $user_uid = null, $invite = 0)
{
    global $db;

    $queue_id = $db->nextId('rakim_queue_id');
    if (is_a($queue_id, 'PEAR_Error')) {
        return $queue_id;
    }

    if (empty($user_uid)) {
        $user_uid = null;
    }

    if ($invite) {
        $status = 'invite';
    } else {
        $status = 'referral';
    }
    $referralQuery = 'INSERT INTO rakim_queues (queue_id, guest_id, user_uid, queue_status, referrer_user_uid)
        VALUES (' . (int)$queue_id . ', ' . (int)$guest_id . ', ' .
        $db->quote($user_uid) . ', ' . $db->quote($status) . ', ' . $db->quote(Auth::getAuth()) . ')';

    $referral_timeQuery = "UPDATE rakim_guests 
        SET guest_referral_time = " . time() . "
        WHERE guest_id = " . (int)$guest_id;

    Horde::logMessage($referralQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);
    Horde::logMessage($referral_timeQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result_i = $db->query($referralQuery);
    $result_u = $db->query($referral_timeQuery);
    if (is_a($result_i, 'PEAR_Error')) {
        Horde::logMessage($result_i, __FILE__, __LINE__, PEAR_LOG_ERR);
    }
    if (is_a($result_u, 'PEAR_Error')) {
        Horde::logMessage($result_u, __FILE__, __LINE__, PEAR_LOG_ERR);
    }

    if ($invite) {
        sendGuestMessage(_("Please wait while I invite another support tech to help."), $guest_id);
    } else {
        sendGuestMessage(_("Please wait while I refer you to another support tech."), $guest_id);

        $updateQueueQuery = "UPDATE rakim_queues
            SET queue_status = 'exit'
            WHERE guest_id = " . (int)$guest_id . "
                AND user_uid = " . $db->quote(Auth::getAuth());

        $result = $db->query($updateQueueQuery);

        unset($_SESSION['rakim']['queue_ids'][$_SESSION['rakim']['guestNumber']]);
        unset($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']]);
        unset($_SESSION['rakim']['guest_names'][$_SESSION['rakim']['guestNumber']]);
        unset($_SESSION['rakim']['guest_remote_addrs'][$_SESSION['rakim']['guestNumber']]);

        $j = 1;
        for ($i = 1; $i <= count($_SESSION['rakim']['guest_ids']); $i++ ) {
            if (isset($_SESSION['rakim']['guest_ids'][$i])) {
                $_SESSION['rakim']['queue_ids'][$j] = $_SESSION['rakim']['queue_ids'][$i]; 
                $_SESSION['rakim']['guest_ids'][$j] = $_SESSION['rakim']['guest_ids'][$i]; 
                $_SESSION['rakim']['guest_names'][$j] = $_SESSION['rakim']['guest_names'][$i]; 
                $_SESSION['rakim']['guest_remote_addrs'][$j] = $_SESSION['rakim']['guest_remote_addrs'][$i]; 
                $j++;
            }
        }
    }
}

require RAKIM_TEMPLATES . '/common-header.inc';

if (Util::getPost('referralSubmit')) {
    referGuest($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']], Util::getPost('referralID'), 0);
    $_SESSION['rakim']['guestNumber'] = 0;
    @session_write_close();
?>

<script language="JavaScript" type="text/javascript">
window.setTimeout("top.rakim_monitor.location.href = '<?php echo Horde::applicationUrl('monitor.php') ?>'", 0);
window.setTimeout("top.rakim_tabs.location.href = '<?php echo Horde::applicationUrl('tabs.php') ?>'", 0);
window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('messages.php') ?>'", 0);
window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('techInput.php') ?>'", 0);
</script>

<?php
} elseif (Util::getPost('invitationSubmit')) {
    referGuest($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']], Util::getPost('referralID'), 1);
?>

<script language="JavaScript" type="text/javascript">
window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('messages.php') ?>'", 0);
window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('input.php') ?>'", 0);
</script>

<?php
    exit;
}

$personnel = $rakim->getActivePersonnel();
if (count($personnel)) {
?>

<form action="refer.php" method="post">
<?php Util::pformInput() ?>
<table>
<tr>
  <td colspan="2">
    <select name="referralID">
      <option value="0"><?php echo _("Everyone") ?></option>
     <?php foreach ($personnel as $tech): if ($tech != Auth::getAuth()): ?>
      <option value="<?php echo $tech ?>"><?php echo $tech ?></option>
     <?php endif; endforeach; ?>
    </select>
    <input class="button" type="submit" name="referralSubmit" value="<?php echo _("Refer") ?>" />
    <input class="button" type="submit" name="invitationSubmit" value="<?php echo _("Invite") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('input.php') ?>'" value="<?php echo _("Cancel") ?>" />
  </td>
</tr>
</table>
</form>

<?php
} else {
    echo '<p>' . _("There are no other personnel available at this time.") . '</p>';
    echo Horde::link(Horde::applicationUrl('input.php'), _("Cancel")) . _("Cancel") . '</a>';
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
