<?php
/**
 * $Horde: rakim/reports.php,v 1.17 2005/01/03 14:35:25 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once RAKIM_BASE . '/lib/DateRange.php';
require_once RAKIM_BASE . '/lib/Reports.php';
require_once 'Horde/Form/Renderer.php';
require_once 'Horde/Variables.php';

if (!Auth::isAdmin('rakim:admin')) {
    Horde::authenticationFailureRedirect();
}

$title = _("Reports");
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';

$chatGraphs = array('doy' => _("Chat activity by day of the year"),
                    'dow' => _("Chat activity by day of the week"),
                    'month' => _("Chat activity by month"),
                    'week' => _("Chat activity by week"),
                    'hour' => _("Chat activity by hour"));

// Load forms.
$r = &new Horde_Form_Renderer();
$vars = &Variables::getDefaultVariables();
$form1 = &Horde_Form::singleton('ChatRangeForm', $vars);
$form2 = &Horde_Form::singleton('EmailRangeForm', $vars);

require RAKIM_TEMPLATES . '/reports/graphs.inc';
$form1->renderActive($r, $vars, 'data.php', 'post');
$form2->renderActive($r, $vars, 'data.php', 'post');
require $registry->get('templates', 'horde') . '/common-footer.inc';
